<?php

namespace app\admin\controller;

use app\common\model\tpzs\Union;
use YearDley\EasyTBK\Factory;
use think\Db;

class Tpzsunion extends Base
{
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->model = new Union();
    }

    public function index()
    {
        if (request()->isPost()) {
            $post_data = input('post.');
            $where = ['admin_id' => $this->adminInfo['id']];
            !empty($post_data['search_key']) && $where['title|unionid'] = ['like', '%' . $post_data['search_key'] . '%'];
            if (isset($post_data['status']) && $post_data['status'] != '')  $where['status'] = $post_data['status'];
            $total = $this->model->total($where, true);
            if ($total) {
                $list = $this->model->getList(
                    [$post_data['page'], $post_data['limit']],
                    $where, [], true, true
                );
            } else {
                $list = [];
            }
            $this->success('success', '', ['total' => $total, 'list' => $list]);
        }

        $builder = new ListBuilder();
        $builder->setSearch([
            ['type' => 'text', 'name' => 'search_key', 'title' => '关键词搜索', 'placeholder' => '名称或联盟ID'],
            ['type' => 'select', 'name' => 'status', 'title' => '状态', 'options' => ['' => '全部', 1 => '启用', 0 => '禁用']]
        ])
            ->addTopButton('addnew', ['title' => '添加京东联盟', 'href' => url('addJd')])
            ->addTableColumn(['title' => '序号', 'field' => 'id', 'type' => 'index','minWidth' => 50])
            ->addTableColumn(['title' => '平台', 'field' => 'type', 'type' => 'enum', 'options' => Union::types(), 'minWidth' => 70])
            ->addTableColumn(['title' => '名称', 'field' => 'title', 'minWidth' => 70])
            ->addTableColumn(['title' => '联盟ID', 'field' => 'unionid', 'minWidth' => 80])
            ->addTableColumn(['title' => '授权key', 'field' => 'app_key', 'minWidth' => 200])
            ->addTableColumn(['title' => '默认', 'field' => 'default', 'type' => 'enum', 'options' => [1 => '是', 0 => '否'], 'minWidth' => 60])
            ->addTableColumn(['title' => '状态', 'field' => 'status', 'type' => 'enum', 'options' => [1 => '启用', 0 => '禁用'], 'minWidth' => 60])
            ->addTableColumn(['title' => '创建时间', 'field' => 'create_time', 'type' => 'datetime', 'minWidth' => 180])
            ->addTableColumn(['title' => '操作', 'minWidth' => 120, 'type' => 'toolbar'])
            ->addRightButton('edit', ['href' => url('editJd', ['id' => '__data_id__'])])
            ->addRightButton('self', ['title' => '推广位', 'href' => url('tpzspos/index', ['union_id' => '__data_id__'])]);

        return $builder->show();
    }

    public function addJd()
    {
        $data['admin_id'] = $this->adminInfo['id'];
        $data['default'] = 0;
        $builder = new FormBuilder();
        $builder->setMetaTitle('新增京东联盟')  //设置页面标题
            ->setPostUrl(url('savepost')) //设置表单提交地址
            ->addFormItem('admin_id', 'hidden', 'created_by')
            ->addFormItem('title', 'text', '名称', '名称', [], 'required')
            ->addFormItem('unionid', 'text', '联盟ID', '联盟ID', [], 'required')
            ->addFormItem('app_key', 'textarea', '授权key', '授权key', [], 'required')
            ->addFormItem('default', 'radio', '是否默认', '是否默认', [1 => '是', 0 => '否'], 'required')
            ->setFormData($data);
        return $builder->show();
    }

    public function editJd()
    {
        $id = input('id');
        $data = $this->model->getOne($id);
        if (!$data) {
            $this->error('id参数错误');
        }
        //使用FormBuilder快速建立表单页面。
        $builder = new FormBuilder();
        $builder->setMetaTitle('编辑京东联盟')  //设置页面标题
            ->setPostUrl(url('savepost')) //设置表单提交地址
            ->addFormItem('id', 'hidden', 'id', 'id')
            ->addFormItem('title', 'text', '名称', '名称', [], 'required')
            ->addFormItem('unionid', 'text', '联盟ID', '联盟ID', [], 'required')
            ->addFormItem('app_key', 'textarea', '授权key', '授权key', [], 'required')
            ->addFormItem('default', 'radio', '是否默认', '是否默认', [1 => '是', 0 => '否'], 'required')
            ->addFormItem('status', 'radio', '状态', '状态', [1 => '启用', 0 => '禁用'], 'required')
            ->setFormData($data);

        return $builder->show();
    }
}
