<?php

namespace app\admin\controller;
use app\common\model\yhq\Code;

class Yhqcode extends Botbase
{
    /**
     * @var Code
     */
    protected $model;
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->model = new Code();
    }

    /**
     * 设置
     * @return mixed
     * @throws \think\Exception
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function index(){
        $coupon_id = input('coupon_id', 0);
        if (request()->isPost()) {
            $post_data = input('post.');
            $where = ['admin_id' => $this->adminInfo['id'], 'coupon_id' => $coupon_id];
            $total = $this->model->total($where, true);
            if ($total) {
                $list = $this->model->getList(
                    [$post_data['page'], $post_data['limit']], $where,
                    ['id' => 'asc'], true, true
                );
            } else {
                $list = [];
            }
            $this->success('success', '', ['total' => $total, 'list' => $list]);
        }

        $builder = new ListBuilder();
        $builder->addTopButton('addnew', ['title' => '导入券码','href' => url('add', ['coupon_id' => $coupon_id])])
            ->setDataUrl(url('index', ['coupon_id' => $coupon_id]))
            ->addTableColumn(['title' => '券码', 'field' => 'code', 'minWidth' => 80])
            ->addTableColumn(['title' => '券链接', 'field' => 'code_url', 'minWidth' => 200])
            ->addTableColumn(['title' => '状态', 'field' => 'status', 'minWidth' => 80,'type' => 'enum','options' => [0 => '禁用', 1=> '启用']])
            ->addTableColumn(['title' => '领取人', 'field' => 'wxid', 'minWidth' => 80,'type' => 'enum','options' => $this->getMembers()])
            ->addTableColumn(['title' => '赠送时间', 'field' => 'send_time', 'minWidth' => 80,'type' => 'datetime'])
            ->addTableColumn(['title' => '操作', 'minWidth' => 150, 'type' => 'toolbar'])
            ->addRightButton('self',['title' => '禁用/启用', 'href' => url('forbidPost', ['id' => '__data_id__']), 'data-ajax' => 1, 'data-confirm' => 1]);

        return $builder->show();
    }

    /**
     * 禁用/启用
     * @throws \think\Exception
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function forbidPost()
    {
        $id = input('id', null);
        $data = $this->model->getOneByMap(['id' => $id, 'admin_id' => $this->adminInfo['id']], true, true);

        if (!$data) {
            $this->error('参数错误');
        }
        $this->model->updateOne([
            'id' => $id,
            'status' => abs($data['status'] - 1)
        ]);
        $this->success('操作成功');
    }

    /**
     * 新增
     * @return mixed
     * @throws \think\Exception
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function add(){
        if(request()->isPost()){
            $post_data = input();
            if(! $list = cache('import' . $post_data['coupon_id'])){
                $this->error('请重新上传文件');
            }
            //$this->error('eee', '', $list);
            $code_exist = $this->model->getField('code', ['coupon_id' => $post_data['coupon_id']], true);
            $insert = [];
            foreach ($list as $v){
                !in_array($v['code'], $code_exist) && $insert[] = [
                    'code' => $v['code'], 'code_url' => $v['code_url'],
                    'admin_id' => $this->adminInfo['id'], 'coupon_id' => $post_data['coupon_id'],
                    'create_time' => time()
                ];
            }
            $this->model->insertAll($insert);
            cache('import' . $post_data['coupon_id'], null);
            $this->success('保存成功');
        }
        $coupon_id = input('coupon_id', 0);

        $import_options = [
            'fields' => ['code' => 'A' ,'code_url' =>  'B'],
            'start_row' => 2,
            'url' => url('importPost', ['coupon_id' => $coupon_id])
        ];
        $builder = new FormBuilder();
        $builder->setPostUrl(url('add', ['coupon_id' => $coupon_id]))
            ->addFormItem('file', 'import_file', '选择文件', '选择文件', $import_options, 'required');

        return $builder->show();
    }

    public function importPost(){
        $list = input('list');
        $coupon_id = input('coupon_id', 0);
        $key = 'import' . $coupon_id;
        if($all = cache($key)){
            $all = array_merge($all, $list);
        }else{
            $all = $list;
        }
        cache($key, $all, 300);
        $this->success('文件上传成功，请点击保存', '', $all);
    }
}